/******************************************************************/
/*                                                                */
/*                      TurboCAD for Windows                      */
/*                   Copyright (c) 1993 - 2001                    */
/*             International Microcomputer Software, Inc.         */
/*                            (IMSI)                              */
/*                      All rights reserved.                      */
/*                                                                */
/******************************************************************/

// ExSymbol.cpp : Implementation of CExSymbol
#include "stdafx.h"
#include "InsertExternalSymbol.h"
#include "ExSymbol.h"
#include "xdbtool_i.c"

/////////////////////////////////////////////////////////////////////////////
// CExSymbol
// This example open selectde drawing, takes all graphics from it, create graphic of type Group that 
// contains all,these graphics and insert this
// Group into current drawing. Notes. It is just simply sample. It works quite well if you
// try insert simple drawing. 



/////////////////////////////////////////////////////////////////////////////
// CExSymbol

COleVariant t(-1L, VT_BOOL);
COleVariant f(0L, VT_BOOL);
COleVariant missing((long)DISP_E_PARAMNOTFOUND, VT_ERROR);
const IID IID_Tool = {0x6A48112C,0xE531,0x11CF,{0xA1,0x15,0x00,0xA0,0x24,0x15,0x8D,0xAF}};
const CLSID CLSID_XGraphic  = {0x6A481803,0xE531,0x11CF,{0xA1,0x15,0x00,0xA0,0x24,0x15,0x8D,0xAF}};
const IID IID_Graphics = {0x6A48110A, 0xE531, 0x11CF, {0xA1,0x15,0x00,0xA0,0x24,0x15,0x8D,0xAF}};

STDMETHODIMP CExSymbol::get_ClassID(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	HRESULT hRes = E_FAIL;
	LPOLESTR olestr = NULL;

	try
	{
		if(SUCCEEDED( ::StringFromCLSID(CLSID_ExSymbol, &olestr)))
		{
			*pVal = ::SysAllocString(olestr);
			hRes = S_OK;
		}
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::get_ClassID")
	}

	if (olestr != NULL)
	CoTaskMemFree(olestr);

	return hRes;
}

STDMETHODIMP CExSymbol::get_Description(BSTR *pVal)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hRes = E_FAIL;
	// Get the description from the resource
	CString strResult;
	if (strResult.LoadString(IDS_DESCRIPTION))
	{
		hRes = S_OK;
		*pVal = strResult.AllocSysString();
	}
	return hRes;
}
STDMETHODIMP CExSymbol::GetToolInfo(VARIANT *CommandNames, VARIANT *MenuCaptions, VARIANT *StatusPrompts, VARIANT *ToolTips, VARIANT *Enabled, VARIANT *WantsUpdates, long *ret)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	HRESULT hRes = E_FAIL;
	
	SAFEARRAYBOUND bound = {NUM_TOOLS, 0};
	SAFEARRAYBOUND bound1[2] = {{NUM_TOOLS, 0}, {2, 0}};

	CString cstrText;
	CString cstrTextTemp;

	BSTR bstrCommandName = NULL;
	BSTR bstrMenuCaption = NULL;
	BSTR bstrStatusPrompt = NULL;
	BSTR bstrToolTip = NULL;
	BOOL bEnabled = TRUE;
	BOOL bWantsUpdates = TRUE;

	
	long lIndicies = 0;
	long lIndicies1[2];
	lIndicies1[0] = 0;
	lIndicies1[1] = 0;
	try
	{
		
		hRes = SafeArrayRedim(CommandNames->parray, &bound);
		CHECK_HRESULT(hRes)

//		hRes = SafeArrayRedim(MenuCaptions->parray, &bound);
//		CHECK_HRESULT(hRes)
		MenuCaptions->parray = SafeArrayCreate(VT_BSTR, 2, bound1);

		hRes = SafeArrayRedim(StatusPrompts->parray, &bound);
		CHECK_HRESULT(hRes)

		hRes = SafeArrayRedim(ToolTips->parray, &bound);
		CHECK_HRESULT(hRes)

		hRes = SafeArrayRedim(Enabled->parray, &bound);
		CHECK_HRESULT(hRes)

		hRes = SafeArrayRedim(WantsUpdates->parray, &bound);
		CHECK_HRESULT(hRes)

		cstrText.LoadString (IDS_MAINMENU);
		cstrText.Insert(cstrText.GetLength (), '|');
		cstrTextTemp.LoadString (IDS_SUBMENU);
		cstrText.Insert(cstrText.GetLength (), cstrTextTemp);
		cstrText.Insert(cstrText.GetLength (), '|');
		cstrTextTemp.LoadString (IDS_MENUCAPTION);
		cstrText.Insert(cstrText.GetLength (), cstrTextTemp);
		cstrTextTemp.Empty ();

		cstrText += "#CMD_SDKINSERTFILE";

		bstrCommandName = cstrText.AllocSysString();
		hRes = SafeArrayPutElement(CommandNames->parray, &lIndicies, (void *)bstrCommandName);
		CHECK_HRESULT(hRes)

		cstrText.Empty ();
		cstrText.LoadString (IDS_MENUCAPTION); 
		bstrMenuCaption = cstrText.AllocSysString();
		hRes = SafeArrayPutElement(MenuCaptions->parray, lIndicies1, (void *)bstrMenuCaption);
		CHECK_HRESULT(hRes)
		cstrText.Empty ();

 		cstrText.LoadString (IDS_PROMT0);
		bstrStatusPrompt = cstrText.AllocSysString();
		hRes = SafeArrayPutElement(StatusPrompts->parray, &lIndicies, (void *)bstrStatusPrompt);
		CHECK_HRESULT(hRes)
		cstrText.Empty ();

		cstrText.LoadString (IDS_TOOLTIPS);; 
		bstrToolTip = cstrText.AllocSysString();
		hRes = SafeArrayPutElement(ToolTips->parray, &lIndicies, (void *)bstrToolTip);
		CHECK_HRESULT(hRes)

		hRes = SafeArrayPutElement(Enabled->parray, &lIndicies, (void *)&bEnabled);
		CHECK_HRESULT(hRes)

		hRes = SafeArrayPutElement(WantsUpdates->parray, &lIndicies, (void *)&bWantsUpdates);
		CHECK_HRESULT(hRes)

// put default toolbar name
		lIndicies1[0] = 0;
		lIndicies1[1] = 1;

		cstrText.LoadString (IDS_TOOLBAR_NAME); 
		bstrMenuCaption = cstrText.AllocSysString();

		hRes = SafeArrayPutElement(MenuCaptions->parray, lIndicies1, (void *)bstrMenuCaption);
		CHECK_HRESULT(hRes)
		cstrText.Empty ();

		*ret = NUM_TOOLS;
	}
	catch (...)
	{
		if (SUCCEEDED(hRes))
			hRes = E_FAIL;
		TRACE_EXCEPTION("CExSymbol::GetToolInfo")
	}
	return hRes;
}

STDMETHODIMP CExSymbol::CopyBitmap(VARIANT_BOOL LargeButtons, VARIANT_BOOL Monochrome, VARIANT_BOOL *ret)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}


STDMETHODIMP CExSymbol::GetPicture(VARIANT_BOOL LargeButtons, VARIANT_BOOL Monochrome, IDispatch **ret)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	LPTSTR IDB = 0;

	HRESULT hRes = E_FAIL;
	try
	{
		if(LargeButtons)
		{
			IDB = MAKEINTRESOURCE(IDB_BMP2);
		}
		else
		{
			IDB = MAKEINTRESOURCE(IDB_BMP1);
		}
		HBITMAP pBmp = ::LoadBitmap(AfxGetResourceHandle(), IDB);

		PICTDESC pict;
		pict.cbSizeofstruct = sizeof(pict);
		pict.picType = PICTYPE_BITMAP;
		pict.bmp.hbitmap = pBmp;
		pict.bmp.hpal = NULL;

		hRes = OleCreatePictureIndirect(&pict, IID_IDispatch, TRUE, (void**)ret);

		CHECK_HRESULT(hRes)
		hRes = S_OK;
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::GetPicture")
	}

	return S_OK;
}
void CorrectGraphic(IGraphic *pIGr)
{
	COleVariant varName("Layer");
	COleVariant varValue("0");
	//Properties *pProps = NULL;
    CComPtr<Properties> pProps;
	//Property *pProp = NULL;
    CComPtr<Property> pProp;
	//Graphics *pGrs = NULL;
    CComPtr<Graphics> pGrs;
	ImsiGraphicType  iGrType;
	//IGraphic *pIGrT = NULL;
    CComPtr<IGraphic> pIGrT;
	HRESULT hRes =  E_FAIL;
	long lCount = 0;
	long lItem = 0;
	COleVariant varItem(lItem);
	try
	{
		
		short iCosm = 0;
		hRes = pIGr->get_Cosmetic(&iCosm);
		if (!iCosm)
		{
			hRes = pIGr->get_Properties(&pProps);
			if (SUCCEEDED(hRes) && pProps)
			{
				hRes = pProps->get_Item (varName, &pProp);
				if (SUCCEEDED(hRes) && pProp)
				{
					hRes = pProp->put_Value (NULL, varValue);

					//RELEASE(pProp)
				}		

				//RELEASE(pProps);
			}

			hRes = pIGr->put_ID(0);
			hRes = pIGr->get_TypeByValue(&iGrType);
			if(iGrType == imsiGroup)
			{
				hRes = pIGr->get_Graphics(&pGrs);
				CHECK_HRESULT(hRes)
				
				hRes = pGrs->get_Count(&lCount);
				CHECK_HRESULT(hRes)

				for (lItem = 0; lItem < lCount; lItem++)
				{
					varItem = lItem;
					hRes = pGrs->get_Item(&varItem, &pIGrT);
					CHECK_HRESULT(hRes)
					CorrectGraphic(pIGrT);
					CHECK_HRESULT(hRes)
					//RELEASE(pIGrT);
                    pIGrT.Release();
				}
			//	RELEASE(pGrs)
			}
		
		}
	}
	catch(...)
	{
/*        RELEASE(pProps);
        RELEASE(pProp);
        RELEASE(pGrs);
        RELEASE(pIGrT);*/
		TRACE("Correct graphic failed");
	}
}

STDMETHODIMP CExSymbol::Run(IDispatch *ThisTool, VARIANT_BOOL *ret)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	HRESULT hRes = E_FAIL;

  // Release all interfaces to prevent memory leaks
    m_pTool.Release();
    m_pITool.Release();
    m_pIToolEvents.Release();
    m_pIApplication.Release();
    m_pDragGraphic.Release();


    CComPtr<IApplication> pIApp;

	CString cstrText;
	CComBSTR bstrStatusPrompt;
	cstrText.LoadString (IDS_PROMT);
	bstrStatusPrompt = cstrText.AllocSysString();
	m_bDragging  = FALSE;

	COleVariant varProp;
	COleVariant varOptional(varMissing);
	COleVariant varType((const long)imsiGroup);
	COleVariant varItem(0L);
	varItem.vt = VT_I4;
	COleVariant varItemTmp(0L);
	varItemTmp.vt = VT_I4;

	CComPtr<IDrawing> pDrSymb;
    CComPtr<Drawings> pDrs;
    CComPtr<Graphics> pGrsSymb;
    CComPtr<IGraphic> pGrTmp;
    CComPtr<IGraphic> pGrCur;
	long lCount;
	long n = 0;

	Filters *pFts = NULL;
	Filter *pFt = NULL;
    CComPtr<IDrawing> pActDr;
	
	typedef Filter* LPFILTER;
	CList<LPFILTER, LPFILTER> lpFts;
	
    CComPtr<Graphics> pDragGrGrs;
		
	IMSI_BOOL bHidden = TRUE;
	
	CComBSTR bstrFileName = NULL;;
	CComBSTR bstrExt;
	CString strExt;
	CString strFileName;
	CString strActFileName;
	CComBSTR bstrActFileName = NULL;;
	strFileName.Empty();
	try
	{
		hRes = ThisTool->QueryInterface(IID_Tool, (void **)&m_pTool);
		CHECK_HRESULT(hRes)

		hRes = m_pTool->get_Application(&m_pIApplication);
		CHECK_HRESULT(hRes)

		hRes = m_pIApplication->get_Filters(&pFts);
		if (SUCCEEDED(hRes) && pFts)
		{
			FOR_EACH (Filter, pFt, pFts)
				hRes = pFt->get_Extension(&varItem, &bstrExt);
				if(SUCCEEDED(hRes))
				{
					strExt = bstrExt;
					if (strExt.CompareNoCase ("BMF") == 0)
					{
						IMSI_BOOL bHidden = FALSE;
						pFt->get_Hidden(&bHidden);
						if (!bHidden)
						{
							bHidden = TRUE;
							hRes = pFt->put_Hidden(bHidden);
							pFt->AddRef();
							lpFts.AddTail (pFt);
						}	
					}
				}
			NEXT (pFt)
		}
		hRes = m_pIApplication->GetOpenFilename(&varMissing, &varMissing, &varMissing, &varMissing, &bstrFileName);
		strFileName = bstrFileName;

		bHidden = FALSE;
		
		if (lpFts.GetCount () > 0)
		{
			POSITION posStart = lpFts.GetHeadPosition();
			pFt = lpFts.GetNext (posStart);
			while (pFt)
			{
				hRes = pFt->put_Hidden(bHidden);
				RELEASE(pFt)
				if (posStart != NULL)
					pFt = lpFts.GetNext (posStart);
			}

		
		}

		RELEASE(pFt)
		RELEASE(pFts)
		
		hRes = m_pIApplication->get_ActiveDrawing(&pActDr);
		if (SUCCEEDED(hRes) && pActDr)
		{
			hRes = pActDr->get_Path(0,&bstrActFileName);
			strActFileName = bstrActFileName;
			if (!strFileName.IsEmpty () && strActFileName.CompareNoCase (strFileName) == 0)
			{
				::SysFreeString (bstrActFileName);
				AfxMessageBox("This sample can't insert drawing in itself!");
				Destroy();			
				return hRes;
			}
			if (strFileName.IsEmpty())
			{	
				Destroy();
                pActDr.Release();
				return hRes;
			}
		}
		hRes = m_pIApplication->get_Drawings(&pDrs);
		CHECK_HRESULT(hRes)
// ----------------------  make the symbol graphic
        IMSI_BOOL bSaved = TRUE;
        hRes = pActDr->get_Saved(&bSaved);
        if (bSaved)
        {
            hRes = pActDr->put_Saved(FALSE);//Set this property to prevent closing of the current drawing
        }
		hRes = pDrs->Open(bstrFileName, &t, &varMissing, &pDrSymb);
		CHECK_HRESULT(hRes)
        pActDr->put_Saved(bSaved);//Set this property to restore the first state of the current drawing

        
    // Set Drawing Space in the active drawing according to the inserted drawing
        COleVariant varPropSpace(CString(_T("TileMode")));
        CComPtr<Properties> pProps;
        CComPtr<Property> pProp;
        hRes = pActDr->get_Properties(&pProps);
        CHECK_HRESULT(hRes)
        hRes = pProps->get_Item(&varPropSpace, &pProp);
        CHECK_HRESULT(hRes)
        pProps.Release();
        hRes = pProp->get_Value(0, &m_drwSpace);
        CHECK_HRESULT(hRes)
        pProp.Release();

        hRes = pDrSymb->get_Properties(&pProps);
        CHECK_HRESULT(hRes)
        hRes = pProps->get_Item(&varPropSpace, &pProp);
        CHECK_HRESULT(hRes)
        pProps.Release();
        hRes = pProp->put_Value(0, &m_drwSpace);
        CHECK_HRESULT(hRes)
        pProp.Release();
    // End of setting Drawing Space

		hRes = pDrSymb->get_Graphics(&pGrsSymb);
		CHECK_HRESULT(hRes)
// create a group graphic and add all graphics from drawing we want to insert in current drawing as child
		hRes = pGrsSymb->Add(&varType,
							 &varMissing,
							 &varOptional,
							 &varOptional,
							 &varOptional,
							 &varOptional,
							 &m_pDragGraphic);					
		CHECK_HRESULT(hRes)
//		CorrectGraphic(m_pDragGraphic);
		
		hRes = pGrsSymb->get_Count(&lCount);
		CHECK_HRESULT(hRes)

		hRes = m_pDragGraphic->get_Graphics(&pDragGrGrs);
		CHECK_HRESULT(hRes)

// It is just example. Be sure that all graphics in drawing that contains symbol 
//are placed on one layer otherwise this code will not work correctly
// (you will get GPF

// Next part is necessary to prevent this GPF

    // Get names of all layers exist in current drawing
        CList<CString, CString&> LayersNameCurDrw;
        Layers* pLrsCur = NULL;
        hRes = pActDr->get_Layers(&pLrsCur);
        CHECK_HRESULT(hRes)
        long lrsCount = 0;
        hRes = pLrsCur->get_Count(&lrsCount);
        CHECK_HRESULT(hRes)
        for(int cntL = 0; cntL < lrsCount; cntL++)
        {
            Layer* pLr = NULL;
            try
            {
                CComBSTR bstrLayerName;
                hRes = pLrsCur->get_Item(&_variant_t((long)cntL), &pLr);
                CHECK_HRESULT(hRes)
                hRes = pLr->get_Name(&bstrLayerName);
                CHECK_HRESULT(hRes)
                LayersNameCurDrw.AddTail(CString(bstrLayerName));
                RELEASE(pLr);
            }
            catch(...)
            {
                RELEASE(pLr);
                RELEASE(pLrsCur);
                throw E_FAIL;
            }
        }
        RELEASE(pLrsCur);
    // End of getting names of all layers exist in current drawing
        
		long lTmp;
		ImsiGraphicType iGrType;
		for (n = 0; n < lCount - 1; n++)//(lCount - 1) to exclude the last graphic that was added as imsiGroup
		{

			varItem = n;
			hRes = pGrsSymb->get_Item(&varItem, &pGrCur);			
			CHECK_HRESULT(hRes)

        // The next code block checks whether a layer(with specific name) exists in current layer
            Layer* pGrLayer = NULL;
            hRes = pGrCur->get_Layer(&pGrLayer);
            CHECK_HRESULT(hRes)
            CComBSTR bstrCurLayer;
            hRes = pGrLayer->get_Name(&bstrCurLayer);
            CHECK_HRESULT(hRes)
            RELEASE(pGrLayer);
            if (bstrCurLayer == L"$CONSTRUCTION")
            {
                LayersNameCurDrw.RemoveAll();
                AfxMessageBox("This sample do not provide drawings with construction layer");
                throw E_FAIL;
            }
            POSITION pos = LayersNameCurDrw.Find(CString(bstrCurLayer));
            if (!pos)
            {
                LayersNameCurDrw.RemoveAll();
                AfxMessageBox("The current drawing do not include layers of inserted drawings");
                throw E_FAIL;
            }
        // End of cheking block

			hRes = pGrCur->get_TypeByValue(&iGrType);
			CHECK_HRESULT(hRes)

			if (iGrType != imsiInsert && iGrType != imsiViewport)
			{
				hRes = pGrCur->Duplicate(&pGrTmp);
				CHECK_HRESULT(hRes)
				hRes = pGrTmp->get_Index(&lTmp);
				CHECK_HRESULT(hRes)
                pGrTmp.Release();

				varItemTmp = lTmp;
				
				hRes = pGrsSymb->Remove(varItemTmp, &pGrTmp);
				CHECK_HRESULT(hRes)
				
				CorrectGraphic(pGrTmp);
				
				hRes = pDragGrGrs->AddGraphic(pGrTmp, &varMissing, &varMissing);
				CHECK_HRESULT(hRes)

                pGrTmp.Release();
			}
            pGrCur.Release();
		}

        pDragGrGrs.Release();

		hRes = QueryInterface(IID_IExSymbol, (void**)&m_pITool);
		CHECK_HRESULT(hRes)

		hRes = m_pIApplication->QueryInterface(IID_IToolEvents, (void **)&m_pIToolEvents);
		hRes = m_pIToolEvents->ToolChangePrompt(m_pITool,bstrStatusPrompt , FALSE);

		ConnectEvents(m_pITool);
		m_bRunned = FALSE;

		long lndex;
		hRes = m_pDragGraphic->get_Index(&lndex);	
		varItem = lndex;		
		
        m_pDragGraphic.Release();

		hRes = pGrsSymb->Remove(&varItem, &m_pDragGraphic);
		CHECK_HRESULT(hRes)

        pGrsSymb.Release();

		hRes = pDrSymb->Close(f, varOptional, varOptional); 
        pDrSymb.Release();

//----------------------------------------------------------------
		*ret = TRUE;
		hRes = S_OK;
	}
	catch (...)
	{
        pDrSymb->Close(f, varOptional, varOptional);
		TRACE_EXCEPTION("CExSymbol::Run")
	}

    pActDr->put_Saved(TRUE);//Set this property to prevent closing of current drawing

    RELEASE(pFt)
    RELEASE(pFts)

    pIApp.Release();
    pDrSymb.Release();
    pDrs.Release();
    pGrsSymb.Release();
    pGrTmp.Release();
    pGrCur.Release();

	pDrs.Release();
    pIApp.Release();

	return hRes;
}

STDMETHODIMP CExSymbol::UpdateToolStatus(IDispatch *ThisTool, VARIANT_BOOL *Enabled, VARIANT_BOOL *Checked, VARIANT_BOOL *ret)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	HRESULT hRes = E_FAIL;

	try 
	{
		// do not allow to run this tool if it is already runned
		if (m_bRunned)
			*Checked = TRUE;
		*ret = TRUE;
		hRes = S_OK;

	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::UpdateToolStatus")
	}
	return hRes;
}

STDMETHODIMP CExSymbol::Initialize(IDispatch *ThisTool, VARIANT_BOOL *ret)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	m_bRunned = FALSE;
	m_pIApplication = NULL;
	m_pITool = NULL;
	m_pTool = NULL;
	m_dwEventConnection = NULL;
	m_pDragGraphic = NULL;
	m_bDragging  = FALSE;
	m_pTCADView = NULL;
	m_bInit = FALSE;
	m_pIToolEvents = NULL;

	return S_OK;
}

STDMETHODIMP CExSymbol::Terminate(IDispatch *ThisTool)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}
STDMETHODIMP CExSymbol::BeforeExit(IDispatch *TheApp, VARIANT_BOOL *Cancel)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

STDMETHODIMP CExSymbol::RunTool(IDispatch *ThisTool)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	HRESULT hRes = E_FAIL;

	try
	{
		Destroy();
		hRes = S_OK;
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::RunTool")
	}

	return hRes;
}

STDMETHODIMP CExSymbol::MouseDown(IDispatch *WhichDrawing, IDispatch *WhichView, IDispatch *WhichWindow, short Button, long Shift, long X, long Y, VARIANT_BOOL *Cancel)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	*Cancel = TRUE;
	HRESULT hRes = E_FAIL;
	COleVariant varOptional(varMissing);

	CPoint point;
	point.x = X;
	point.y = Y;

    CComPtr<View> pCurrentTCView;
	pCurrentTCView = (View*)WhichView;
	//pCurrentTCView->AddRef();
	
	double z;
    CComPtr<Graphics> pGrs;
    CComPtr<IDrawing> pDr;
	pDr = (IDrawing*)WhichDrawing;
	//pDr->AddRef();
    CComPtr<IGraphic> pGr;
//	long lGrId = 0;
	z = 0;
	CString cstrUndo;

    if (V_VT(&m_drwSpace) == VT_EMPTY) return S_OK;

	try
	{
		if (Button == 1)
		{
			hRes = pDr->get_Graphics(&pGrs);
			CHECK_HRESULT(hRes)

			hRes = m_pDragGraphic->put_ID(0);
			hRes = pGrs->AddGraphic(m_pDragGraphic, varOptional, varOptional);
			CHECK_HRESULT(hRes)

			hRes = m_pDragGraphic->Update();
			CHECK_HRESULT(hRes)

//			hRes = m_pDragGraphic->get__Handle(&lGrId);

			EndDrag(point);
            m_pDragGraphic.Release();
			m_pTCADView->Refresh();
            m_pTCADView.Release();
		}
		else
        {
            EndDrag(point);
        }
		hRes = S_OK;	
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::MouseDown")
	}

	Destroy();

	return S_OK;
}

STDMETHODIMP CExSymbol::MouseUp(LPDISPATCH WhichDrawing, LPDISPATCH WhichView, LPDISPATCH WhichWindow, short Button, long Shift, long X, long Y, IMSI_BOOL *pbCancel)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	*pbCancel = TRUE;
	return S_OK;

}
STDMETHODIMP CExSymbol::MouseMove(LPDISPATCH WhichDrawing, LPDISPATCH WhichView, LPDISPATCH WhichWindow, long Shift, long X, long Y, IMSI_BOOL *pbCancel)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())
	*pbCancel = FALSE;

	CPoint point;
	point.x = X;
	point.y = Y;

    CComPtr<View> pCurrentTCView;
    CComPtr<IDrawing> pDr;
	pDr = (IDrawing*)WhichDrawing;
	//pDr->AddRef();

    if (V_VT(&m_drwSpace) != VT_EMPTY)
    {
    	try
    	{
    		if (!m_bDragging)
    		{
    			m_pTCADView = (View*)WhichView;
    			//m_pTCADView->AddRef();
    			BeginDrag(point);
    		}
    		else
    		{
    			pCurrentTCView = (View*)WhichView;
    			//pCurrentTCView->AddRef();
    			ASSERT(m_pTCADView);
    			if (pCurrentTCView != m_pTCADView)
    			{
                    m_pTCADView.Release();

    				m_pTCADView = (View*)WhichView;
    				//m_pTCADView->AddRef();
                    
    				RestartDrag(point);			
    			}

                ImsiSpaceModeType curMode;
                CHECK_HRESULT(m_pTCADView->get_SpaceMode(&curMode))
                if (m_drwSpace.iVal != curMode)
                {
                    EndDrag(point);
                    ::VariantClear(&m_drwSpace);
                    throw S_OK;
                }
                
    			Drag(point);
    		}
    	}
    	catch (...)
    	{
    		TRACE_EXCEPTION("CExSymbol::MouseMove")
    	}
    }	
	return S_OK;
}


STDMETHODIMP CExSymbol::SelectionChange(IDispatch *WhichDrawing, IDispatch *WhichView, IDispatch *WhichWindow, IDispatch *Sel)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

STDMETHODIMP CExSymbol::PointSnapped(IDispatch *WhichDrawing, IDispatch *WhichView, long X, long Y, IDispatch *PointRaw, IDispatch *PointSnapped)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	// TODO: Add your implementation code here

	return S_OK;
}

void CExSymbol::ConnectEvents(IDispatch *ThisTool)
{

 	HRESULT hRes = S_OK;

	if (m_dwEventConnection != 0)
	{
		return;
	}

	try
	{

		DWORD dwEventMask = imsiEventMouseUp
							 | imsiEventMouseMove
							 | imsiEventMouseDown
							 | imsiEventDrawingDeactivate
							 | imsiEventRunTool
							 | imsiEventBeforeExit;

		COleVariant var((long)dwEventMask);
		hRes = m_pIApplication->ConnectEvents(ThisTool,
			&var,
			(long*)&m_dwEventConnection);
		
		if (FAILED(hRes))
			return;
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::ConnectEvents")
	}
}

void CExSymbol::DisconnectEvents()
{
	if (m_pIApplication == NULL || m_dwEventConnection == 0)
		return;

	try 
	{
		HRESULT	hRes = m_pIApplication->DisconnectEvents(m_dwEventConnection);
		CHECK_HRESULT(hRes)
		if (FAILED(hRes))
			return;
		m_dwEventConnection = 0;
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::DisconnectEvents")
	}
}



///------------------------------------------
// DragOutline functions
BOOL CExSymbol::BeginDrag(const CPoint& point)
{
	VariantClear(&m_dragOutline);
	SAFEARRAYBOUND bound;
	bound.cElements = 0;
	bound.lLbound = 0;
	m_dragOutline.vt = VT_ARRAY|VT_R8;
	m_dragOutline.parray = ::SafeArrayCreate(VT_R8, 1, &bound);

    CComPtr<BoundingBox> Box;
    CComPtr<IVertex> vMax;
    CComPtr<IVertex> vMin;
	double x, y, x1, y1;
	x = x1 = y = y1 = 0;
	try
	{
		HRESULT hRes = m_pDragGraphic->CreateDragOutline(&m_dragOutline);
		CHECK_HRESULT(hRes)

		m_bDragging = TRUE;
		m_pDragGraphic->put_Visible(FALSE);
        COleVariant varState;
		varState.vt = VT_I4;
		varState.lVal = imsiDragBegin;

		hRes = m_pDragGraphic->CalcBoundingBox(NULL, &Box);
		CHECK_HRESULT(hRes)

		hRes = Box->get_Max(&vMax);
		CHECK_HRESULT(hRes)

		hRes = Box->get_Min(&vMin);
		CHECK_HRESULT(hRes)

		hRes = vMax->get_X(&x);
		CHECK_HRESULT(hRes)

		hRes = vMax->get_Y(&y);
		CHECK_HRESULT(hRes)

		hRes = vMin->get_X(&x1);
		CHECK_HRESULT(hRes)

		hRes = vMin->get_Y(&y1);
		CHECK_HRESULT(hRes)

		x = x1 + (x - x1)/2;
		y = y1 + (y - y1)/2;
		hRes = m_pTCADView->ViewToScreen(x, y, &x1, &y1, NULL);
		CHECK_HRESULT(hRes)

		hRes = m_pTCADView->DragOutline(&m_dragOutline, x1, y1, &varState);
		CHECK_HRESULT(hRes)
		

		varState.lVal = imsiDragContinue;
		hRes = m_pTCADView->DragOutline(&m_dragOutline, point.x, point.y, &varState);
		CHECK_HRESULT(hRes)
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::BeginDrag")
	}

	return TRUE;
}

void CExSymbol::Drag(const CPoint& point)
{
	if (m_pTCADView == NULL)
		return;

    COleVariant varState;
	varState.vt = VT_I4;
	varState.lVal = imsiDragContinue;

	try
	{
		HRESULT hRes = m_pTCADView->DragOutline(&m_dragOutline, point.x, point.y, &varState);
		CHECK_HRESULT(hRes)
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::Drag")
	}
	
}

void CExSymbol::EndDrag(const CPoint& point)
{
	m_bDragging = FALSE;
	if (m_pTCADView == NULL || m_pDragGraphic == NULL)
		return;

    COleVariant varState;
	varState.vt = VT_I4;
	varState.lVal = imsiDragEnd;
    CComPtr<IMatrix> pMat;

	try 
	{
		HRESULT hRes = m_pTCADView->DragOutline(&m_dragOutline, point.x, point.y, &varState);
		CHECK_HRESULT(hRes)

		VariantClear(&m_dragOutline);

		double dx, dy, dz;
		dx = dy = dz = 0;

		double dxWorld, dyWorld, dzWorld;
		dxWorld = dyWorld = dzWorld = 0;
		hRes = m_pTCADView->ScreenToView(point.x, point.y, &dx, &dy);
		CHECK_HRESULT(hRes)

        COleVariant var;
		var.vt = VT_ERROR;
		var.scode = DISP_E_PARAMNOTFOUND;

		ImsiSpaceModeType curMode;	

		hRes = m_pTCADView->get_SpaceMode(&curMode);
		CHECK_HRESULT(hRes)
		dxWorld = dx;
		dyWorld = dy; 

		if(curMode == imsiModelSpace)
		{
			hRes = m_pTCADView->ViewToWorld(dx, dy, dz, &dxWorld, &dyWorld, &dzWorld);
			CHECK_HRESULT(hRes)
		}
		hRes = m_pDragGraphic->MoveAbsolute(dxWorld, dyWorld, 0, &var, &var, &var, &pMat);
		CHECK_HRESULT(hRes)
		hRes = m_pDragGraphic->put_Visible(TRUE);
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::EndDrag")
	}
	
    m_pDragGraphic.Release();
}

void CExSymbol::RestartDrag(const CPoint& point)
{
	try
	{
		m_bDragging = FALSE;
        COleVariant varState;
		varState.vt = VT_I4;
		varState.lVal = imsiDragEnd;
		HRESULT hRes = m_pTCADView->DragOutline(&m_dragOutline, point.x, point.y, &varState);
		CHECK_HRESULT(hRes)

		VariantClear(&m_dragOutline);
		BeginDrag(point);
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::RestartDrag")
	}
}


void CExSymbol::Destroy()
{
	CString cstrT;
	cstrT.Empty ();
	BSTR bstrPromt = NULL;
	bstrPromt = cstrT.AllocSysString();
	if (m_pIToolEvents)
		m_pIToolEvents->ToolChangePrompt(m_pITool, bstrPromt, FALSE);
    ::SysFreeString(bstrPromt);

    m_pIToolEvents.Release();
    DisconnectEvents();
    m_pDragGraphic.Release();
    m_pITool.Release();
    m_pIApplication.Release();
    m_pTool.Release();
		
	m_bRunned = FALSE;
}

STDMETHODIMP CExSymbol::DrawingBeforeClose(LPDISPATCH WhichDrawing, VARIANT_BOOL *Cancel)
{
	AFX_MANAGE_STATE(AfxGetStaticModuleState())

	HRESULT hRes = E_FAIL;
    CComPtr<Drawings> pDrs;
	long n = 0;
	*Cancel = FALSE;

	try 
	{
		hRes = m_pIApplication->get_Drawings(&pDrs);
		CHECK_HRESULT(hRes)
		hRes = pDrs->get_Count(&n);
		CHECK_HRESULT(hRes)
	
		if (n == 1)
		{
			Destroy();
		}
	}
	catch (...)
	{
		TRACE_EXCEPTION("CExSymbol::DrawingBeforeClose")
	}
	
	//RELEASE(pDrs)

	return S_OK;
}

STDMETHODIMP CExSymbol::DrawingDeactivate( IDispatch *WhichDrawing)
{
	return S_OK;
}

BOOL CExSymbol::Init()
{
	m_bInit = true;
	return m_bInit;
}
