/******************************************************************/
/*                                                                */
/*                      TurboCAD for Windows                      */
/*                   Copyright (c) 1993 - 2001                    */
/*             International Microcomputer Software, Inc.         */
/*                            (IMSI)                              */
/*                      All rights reserved.                      */
/*                                                                */
/******************************************************************/

// ExSymbol.h : Declaration of the CExSymbol

#ifndef __EXSYMBOL_H_
#define __EXSYMBOL_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CExSymbol
class ATL_NO_VTABLE CExSymbol : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CExSymbol, &CLSID_ExSymbol>,
	public IDispatchImpl<IExSymbol, &IID_IExSymbol, &LIBID_INSERTEXTERNALSYMBOLLib>
{
public:
	CExSymbol()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_EXSYMBOL)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CExSymbol)
	COM_INTERFACE_ENTRY(IExSymbol)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

// IExSymbol
public:
    CComPtr<Tool> m_pTool;
    CComPtr<IExSymbol> m_pITool;
    CComPtr<IToolEvents> m_pIToolEvents;

	BOOL m_bRunned;
	BOOL m_bInit;
    CComPtr<IApplication> m_pIApplication;
	DWORD m_dwEventConnection;
	
	void DisconnectEvents();
	void ConnectEvents(IDispatch *ThisTool);
	BOOL BeginDrag(const CPoint& point);
	void Drag(const CPoint& point);
	void RestartDrag(const CPoint& point);
	void EndDrag(const CPoint& point);
	void Destroy();
	BOOL Init();

    COleVariant m_dragOutline;
    COleVariant m_drwSpace;
    CComPtr<IGraphic> m_pDragGraphic;
	BOOL m_bDragging;
    CComPtr<View> m_pTCADView;

	
	STDMETHOD(get_Description)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(get_ClassID)(/*[out, retval]*/ BSTR *pVal);
	STDMETHOD(MouseDown)(/*[in]*/IDispatch *WhichDrawing, /*[in]*/IDispatch *WhichView, /*[in]*/IDispatch *WhichWindow, /*[in]*/short Button, /*[in]*/long Shift, /*[in]*/long X, /*[in]*/long Y, /*[in, out]*/VARIANT_BOOL *Cancel);
	STDMETHOD(MouseMove)(LPDISPATCH WhichDrawing, LPDISPATCH WhichView, LPDISPATCH WhichWindow, long Shift, long X, long Y, IMSI_BOOL* pbCancel);
	STDMETHOD(MouseUp)(LPDISPATCH WhichDrawing, LPDISPATCH WhichView, LPDISPATCH WhichWindow, short Button, long Shift, long X, long Y, IMSI_BOOL* pbCancel);
	STDMETHOD(SelectionChange)(/*[in]*/ IDispatch *WhichDrawing, /*[in]*/ IDispatch *WhichView, /*[in]*/  IDispatch *WhichWindow, /*[in]*/ IDispatch *Sel );
	STDMETHOD(RunTool)(/*[in]*/ IDispatch * ThisTool);
	STDMETHOD(BeforeExit)(/*[in]*/ IDispatch* TheApp, /*[in, out]*/ VARIANT_BOOL* Cancel);
	STDMETHOD(Terminate)(/*[in]*/ IDispatch * ThisTool);
	STDMETHOD(Initialize)(/*[in]*/ IDispatch * ThisTool, /*[out, retval]*/ VARIANT_BOOL* ret);
	STDMETHOD(UpdateToolStatus)(/*[in]*/ IDispatch* ThisTool, /*[in, out]*/ VARIANT_BOOL* Enabled, /*[in, out]*/ VARIANT_BOOL* Checked, /*[out, retval]*/ VARIANT_BOOL* ret);
	STDMETHOD(Run)(/*[in]*/ IDispatch* ThisTool, /*[out, retval]*/ VARIANT_BOOL* ret);
	STDMETHOD(GetPicture)(/*[in]*/ VARIANT_BOOL LargeButtons, /*[in]*/ VARIANT_BOOL Monochrome, /*[out, retval]*/ IDispatch** ret);
	STDMETHOD(CopyBitmap)(/*[in]*/ VARIANT_BOOL LargeButtons, /*[in]*/ VARIANT_BOOL Monochrome, /*[out, retval]*/ VARIANT_BOOL* ret);
	STDMETHOD(GetToolInfo)(/*[in, out]*/ VARIANT* CommandNames, /*[in, out]*/ VARIANT* MenuCaptions, /*[in, out]*/ VARIANT* StatusPrompts, /*[in, out]*/ VARIANT* ToolTips, /*[in, out]*/ VARIANT* Enabled, /*[in, out]*/ VARIANT* WantsUpdates, /*[out, retval]*/ long* ret);
	STDMETHOD(PointSnapped)(/*[in]*/  IDispatch *WhichDrawing, /*[in]*/ IDispatch  *WhichView, /*[in]*/ long X, /*[in]*/ long Y, /*[in]*/ IDispatch *PointRaw, /*[in]*/ IDispatch  *PointSnapped);
	STDMETHOD(DrawingDeactivate)(/* [in]*/ IDispatch *WhichDrawing);	
	STDMETHOD(DrawingBeforeClose)( /*[in]*/ LPDISPATCH WhichDrawing, VARIANT_BOOL* Cancel);

	
	
};

#endif //__EXSYMBOL_H_
